package incarceration;

public class Couple {
	private Agent male = new Agent();
	private Agent female = new Agent();
	private int numMonthsDating = 0;
	private int id = 0;
	private boolean isMarried = false;
	public double startTime; //time step during which couple becomes sexually active
	public double endTime = 999; //time step during which the couple breaks up
	public boolean isBroken = false;
	public double probIncarcerationBreakup = 0.5; //probability that an incarcerated agent's
												  //relationship ends during incarceration
	public static Model model;
	
	// public int rDebug = 0;
	
	public Couple() {}
	
	public Couple (int _id, Agent _male, Agent _female) {
		this.id = _id;
		this.male = _male;
		this.female = _female;
		numMonthsDating++;
		
	}
	
	public void update() {
		numMonthsDating++;
		if (shouldBreakRelationship()) {
			breakRelationship(getMale(), getFemale());
		}
		else if (shouldMarry()) {
		    male.getPartners().add(female);
	    	if ( model.getRDebug() > 1 ){
	    	  	System.out.printf( "\n Added %3d to Partners of %3d", female.getID(), male.getID() );
	    	}
	    	male.getPotentialPartners().remove(female);
		    if (male.getLifetimePartners().contains(female) == false) {
		    	male.getLifetimePartners().add(female);
		    	if ( model.getRDebug() > 1 )
		    		System.out.printf( "\n Added %3d to Lifetime Partners of %3d", female.getID(), male.getID() );
		    }
		    female.getPartners().add(male);
		    female.getPotentialPartners().remove(male);
		    if (female.getLifetimePartners().contains(male) == false) {
		    	female.getLifetimePartners().add(male);
		    	if ( model.getRDebug() > 1 )
		    		System.out.printf( "\n Added %3d to Lifetime Partners of %3d", male.getID(), female.getID() );
		    }
		    setMarried(true);
		    setStartTime(model.getTickCount());
		    if ( model.getRDebug() > 1 )
		    	System.out.println("\n New Sex Partners: Male: " + male.getID() 
					+ "and  Female: " + female.getID());
		}
	}
	
	public boolean shouldMarry() {
		if (numMonthsDating >= male.getCourtShipDuration()
				&& numMonthsDating >= female.getCourtShipDuration()){
			if (male.lifetimePartners.size() < male.getMaxPartners()
		        && female.lifetimePartners.size() < female.getMaxPartners()){
				return true;
			}
			// allow for partner switching
			else if (male.lifetimePartners.size() >= male.getMaxPartners()){
				//if (model.getRDebug() > 0){
				//	System.out.printf("Send to to compare partners");
				//}
				Agent replacedF = male.comparePartners(female, male.partners);
				if (replacedF == null){
					//if (model.getRDebug() > 0){
					//	System.out.printf("\n No female replaceable partner found \n");
					//}
					return false;
				}
				else{
					if (female.lifetimePartners.size() < female.getMaxPartners()){
						if (model.getRDebug() > 1){
							System.out.printf("\n ReplacedF = %3d \n", replacedF.getID());
						}
						breakRelationship(male, replacedF);
						male.courtshipBroken(replacedF);
						replacedF.courtshipBroken(male);
						if (model.getRDebug() > 1){
							System.out.printf("\n Partnership %3d - %3d ended \n", male.getID(), replacedF.getID());
						}
						return true;
					}
					else if (female.lifetimePartners.size() >= female.getMaxPartners()){
						Agent replacedM = female.comparePartners(male, female.partners);
						if (replacedM == null){
							//if (model.getRDebug() > 0){
							//	System.out.printf("\n No male replaceable partner found \n");
							//}
							return false;
						}
						else{
							if (model.getRDebug() > 1){
								System.out.printf("\n ReplacedM = %3d \n", replacedM.getID());
							}
							breakRelationship(female, replacedM);
							female.courtshipBroken(replacedM);
							replacedM.courtshipBroken(female);
							if (model.getRDebug() > 1){
								System.out.printf("\n Partnership %3d - %3d ended \n", female.getID(), replacedM.getID());
							}
							return true;
						}
						}
					}
			}
		}
		return false;
	}
	
	public boolean shouldMarry1() {
		if (numMonthsDating >= male.getCourtShipDuration()
				&& numMonthsDating >= female.getCourtShipDuration()){
			if (male.partners.size() < male.getMaxPartners()
		        && female.partners.size() < female.getMaxPartners()){
				return true;
			}
			// allow for partner switching
			else if (male.partners.size() >= male.getMaxPartners()){
				//if (model.getRDebug() > 0){
				//	System.out.printf("Send to to compare partners");
				//}
				Agent replacedF = male.comparePartners(female, male.partners);
				if (replacedF == null){
					//if (model.getRDebug() > 0){
					//	System.out.printf("\n No female replaceable partner found \n");
					//}
					return false;
				}
				else{
					if (female.partners.size() < female.getMaxPartners()){
						if (model.getRDebug() > 1){
							System.out.printf("\n ReplacedF = %3d \n", replacedF.getID());
						}
						breakRelationship(male, replacedF);
						male.courtshipBroken(replacedF);
						replacedF.courtshipBroken(male);
						if (model.getRDebug() > 1){
							System.out.printf("\n Partnership %3d - %3d ended \n", male.getID(), replacedF.getID());
						}
						return true;
					}
					else if (female.partners.size() >= female.getMaxPartners()){
						Agent replacedM = female.comparePartners(male, female.partners);
						if (replacedM == null){
							//if (model.getRDebug() > 0){
							//	System.out.printf("\n No male replaceable partner found \n");
							//}
							return false;
						}
						else{
							if (model.getRDebug() > 1){
								System.out.printf("\n ReplacedM = %3d \n", replacedM.getID());
							}
							breakRelationship(female, replacedM);
							female.courtshipBroken(replacedM);
							replacedM.courtshipBroken(female);
							if (model.getRDebug() > 1){
								System.out.printf("\n Partnership %3d - %3d ended \n", female.getID(), replacedM.getID());
							}
							return true;
						}
						}
					}
			}
		}
		return false;
	}
	
	//to be replaced with meeting frequency later on
	//right now, there is a probability
	//stupid one though
	public boolean shouldBreakRelationship() {
		Agent male = getMale();
		Agent female = getFemale();
		
		if (male.getIncarcerated() == true){
			return Math.random() < probIncarcerationBreakup ? true : false;
		}
		if (female.getIncarcerated() == true){
			return Math.random() < probIncarcerationBreakup ? true : false;
		}
		
		if (numMonthsDating < 2) {
			return Math.random() < 0.010 ? true : false;
		}
		else if (numMonthsDating >= 2 && numMonthsDating < 5) {
			return Math.random() < 0.015 ? true : false;
		}
		else if (numMonthsDating >= 5 && numMonthsDating < 7) {
			return Math.random() < 0.025 ? true : false;
		}
		else if (numMonthsDating >= 7 && numMonthsDating < 9) {
			return Math.random() < 0.015 ? true : false;
		}
		else {
			return Math.random() < 0.010 ? true : false;	
		}	
	}
	
	public void breakRelationship(Agent male, Agent female){
		male.courtshipBroken(female);
		female.courtshipBroken(male);
		for (Couple couple: male.currentCouples){
			if (model.getRDebug() > 1){
				System.out.printf("\n Current Couples\n");
				for (Couple print: male.currentCouples){
					System.out.printf("%3d \n", print.getId());
				}
			}
			if (couple.getMale() == male && couple.getFemale() == female){
				couple.setEndTime(model.getTickCount());
				couple.isBroken = true;
				if (model.getRDebug() > 1){
					System.out.printf("\n Couple %3d broken \n", couple.getId());
				}
				male.currentCouples.remove(couple);
				female.currentCouples.remove(couple);
				if (model.getRDebug() > 1){
					System.out.printf("\n Male's Current Couples post-break\n");
					for (Couple print: male.currentCouples){
						System.out.printf("%3d \n", print.getId());
					}
				}
				break;
			}
		}	
	}
	
	public Agent getFemale() {
		return female;
	}
	public void setFemale(Agent female) {
		this.female = female;
	}
	public Agent getMale() {
		return male;
	}
	public void setMale(Agent male) {
		this.male = male;
	}
	public int getNumMonthsDating() {
		return numMonthsDating;
	}
	public void setNumMonthsDating(int numMonthsDating) {
		this.numMonthsDating = numMonthsDating;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public boolean isMarried() {
		return isMarried;
	}

	public void setMarried(boolean isMarried) {
		this.isMarried = isMarried;
	}
	
	public double getStartTime(){ return startTime; }
	public void setStartTime( double s ){ startTime = s; }
	
	public double getEndTime(){ return endTime; }
	public void setEndTime( double e ){ endTime = e; }

	public boolean isBroken() {
		return isBroken;
	}

	public void setBroken(boolean isBroken) {
		this.isBroken = isBroken;
	}
	
	public static void setModel(Model m){ model = m; }
	public Model getModel() { return model; }
	
	public double getProbIncarcerationBreakup() { return probIncarcerationBreakup; }
	public void setProbIncarcerationBreakup( double p ) { probIncarcerationBreakup = p; }

}
